/*
 * $Id: Functionnal_unit_deallocation.cpp 136 2009-10-20 18:52:15Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h"
#include "Behavioural/include/Allocation.h"

namespace morpheo                    {
namespace behavioural {
namespace core {
namespace multi_execute_loop {
namespace execute_loop {
namespace multi_execute_unit {
namespace execute_unit {
namespace functionnal_unit {


#undef  FUNCTION
#define FUNCTION "Functionnal_unit::deallocation"
  void Functionnal_unit::deallocation (void)
  {
    log_printf(FUNC,Functionnal_unit,FUNCTION,"Begin");

    if (usage_is_set(_usage,USE_SYSTEMC))
      {
	delete    in_CLOCK ;
	delete    in_NRESET;
	
        DELETE0_SIGNAL( in_EXECUTE_IN_VAL                   ,1);
        DELETE0_SIGNAL(out_EXECUTE_IN_ACK                   ,1);
        DELETE0_SIGNAL( in_EXECUTE_IN_CONTEXT_ID            ,_param->_size_context_id   );
        DELETE0_SIGNAL( in_EXECUTE_IN_FRONT_END_ID          ,_param->_size_front_end_id );
        DELETE0_SIGNAL( in_EXECUTE_IN_OOO_ENGINE_ID         ,_param->_size_ooo_engine_id);
        DELETE0_SIGNAL( in_EXECUTE_IN_PACKET_ID             ,_param->_size_rob_ptr      );
        DELETE0_SIGNAL( in_EXECUTE_IN_OPERATION             ,_param->_size_operation    );
        DELETE0_SIGNAL( in_EXECUTE_IN_TYPE                  ,_param->_size_type         );
        DELETE0_SIGNAL( in_EXECUTE_IN_CANCEL                ,1);
        DELETE0_SIGNAL( in_EXECUTE_IN_STORE_QUEUE_PTR_WRITE ,_param->_size_store_queue_ptr);
        DELETE0_SIGNAL( in_EXECUTE_IN_STORE_QUEUE_PTR_READ  ,_param->_size_store_queue_ptr);
        DELETE0_SIGNAL( in_EXECUTE_IN_STORE_QUEUE_EMPTY     ,1);
        DELETE0_SIGNAL( in_EXECUTE_IN_LOAD_QUEUE_PTR_WRITE  ,_param->_size_load_queue_ptr);
        DELETE0_SIGNAL( in_EXECUTE_IN_HAS_IMMEDIAT          ,1);
        DELETE0_SIGNAL( in_EXECUTE_IN_IMMEDIAT              ,_param->_size_general_data);
        DELETE0_SIGNAL( in_EXECUTE_IN_DATA_RA               ,_param->_size_general_data);
        DELETE0_SIGNAL( in_EXECUTE_IN_DATA_RB               ,_param->_size_general_data);
        DELETE0_SIGNAL( in_EXECUTE_IN_DATA_RC               ,_param->_size_special_data);
        DELETE0_SIGNAL( in_EXECUTE_IN_WRITE_RD              ,1);
        DELETE0_SIGNAL( in_EXECUTE_IN_NUM_REG_RD            ,_param->_size_general_register);
        DELETE0_SIGNAL( in_EXECUTE_IN_WRITE_RE              ,1);
        DELETE0_SIGNAL( in_EXECUTE_IN_NUM_REG_RE            ,_param->_size_special_register);

        DELETE0_SIGNAL(out_EXECUTE_OUT_VAL            ,1);
        DELETE0_SIGNAL( in_EXECUTE_OUT_ACK            ,1);
        DELETE0_SIGNAL(out_EXECUTE_OUT_CONTEXT_ID     ,_param->_size_context_id   );
        DELETE0_SIGNAL(out_EXECUTE_OUT_FRONT_END_ID   ,_param->_size_front_end_id );
        DELETE0_SIGNAL(out_EXECUTE_OUT_OOO_ENGINE_ID  ,_param->_size_ooo_engine_id);
        DELETE0_SIGNAL(out_EXECUTE_OUT_PACKET_ID      ,_param->_size_rob_ptr    );
      //DELETE0_SIGNAL(out_EXECUTE_OUT_OPERATION      ,_param->_size_operation    );
      //DELETE0_SIGNAL(out_EXECUTE_OUT_TYPE           ,_param->_size_type         );
        DELETE0_SIGNAL(out_EXECUTE_OUT_CANCEL         ,1);
        DELETE0_SIGNAL(out_EXECUTE_OUT_WRITE_RD       ,1);
        DELETE0_SIGNAL(out_EXECUTE_OUT_NUM_REG_RD     ,_param->_size_general_register);
        DELETE0_SIGNAL(out_EXECUTE_OUT_DATA_RD        ,_param->_size_general_data);
        DELETE0_SIGNAL(out_EXECUTE_OUT_WRITE_RE       ,1);
        DELETE0_SIGNAL(out_EXECUTE_OUT_NUM_REG_RE     ,_param->_size_special_register);
        DELETE0_SIGNAL(out_EXECUTE_OUT_DATA_RE        ,_param->_size_special_data);
        DELETE0_SIGNAL(out_EXECUTE_OUT_EXCEPTION      ,_param->_size_exception);
        DELETE0_SIGNAL(out_EXECUTE_OUT_NO_SEQUENCE    ,1);
        DELETE0_SIGNAL(out_EXECUTE_OUT_ADDRESS        ,_param->_size_instruction_address);

        // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
        
        for (uint32_t i=0; i<_param->_nb_type; i++)
        delete [] _function_execute [i];
        delete [] _function_execute;

	for (uint32_t i=0; i<_param->_nb_context; i++)
          {
            for (uint32_t j=0; j<_param->_nb_front_end; j++)
              {
                for (uint32_t k=0; k<_param->_nb_ooo_engine; k++)
                delete    _execute_register [i][j][k];
                delete [] _execute_register [i][j];
              }
            delete [] _execute_register [i];
          }
        delete [] _execute_register;

        delete    _execute_param;
        delete    _execute_operation_out;
        if (_param->_have_pipeline_in)
        delete    _execute_operation_in;
      }

    delete    _component;

    log_printf(FUNC,Functionnal_unit,FUNCTION,"End");
  };

}; // end namespace functionnal_unit
}; // end namespace execute_unit
}; // end namespace multi_execute_unit
}; // end namespace execute_loop
}; // end namespace multi_execute_loop
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              
